;
; Copyright (C) 2006 Johannes Hausensteiner (johannes.hausensteiner@pcl.at)
;
; This program is free software; you can redistribute it and/or
; modify it under the terms of the GNU General Public License
; as published by the Free Software Foundation; either version 2
; of the License, or (at your option) any later version.
;
; This program is distributed in the hope that it will be useful,
; but WITHOUT ANY WARRANTY; without even the implied warranty of
; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
; GNU General Public License for more details.
;
; You should have received a copy of the GNU General Public License
; along with this program; if not, write to the Free Software
; Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
;
;
; Filename: diy_calc.inc
;
; Function: standard definitions for the DIY Calculator
;
;
; Changelog
;
;  0.1    6.Sep.2006   JH   new
;
;

; RAM addresses
RAMSTART:  .EQU    $4000      ; start of RAM
RAMEND:    .EQU    $EFFF      ; end of RAM

; the key pad
KEYPAD:    .EQU    $F011      ; address of input port for keypad

; read the interrupt source
IRQ_SRC:   .EQU    $F012      ; address of input port for IRQ source
; bit masks
IRQ_IRQ:   .EQU    $01        ; external IRQ
IRQ_UART:  .EQU    $02        ; UART rx ready
IRQ_RUN:   .EQU    $04        ; RUN button
IRQ_STEP:  .EQU    $08        ; Single Step button
IRQ_COLD:  .EQU    $80        ; determine cold/warm reset

; the hardware version
HW_REV:    .EQU    $F013      ; address of input port for version

; LCD (main display)
MAINDISP:  .EQU    $F031      ; address of output port for main display
; control codes for display
CLRCODE:   .EQU    $10        ; Special code to clear the main display
BEEPCODE:  .EQU    $11        ; Special code to emit a short beep
BKSPCODE:  .EQU    $12        ; Special code for "Backspace"

; user LEDs
SIXLEDS:   .EQU    $F032      ; Address of output port for six LEDs
; bit masks for LEDs
HEXMODE:   .EQU    $01        ; LED code to indicate hexadecimal mode
DECMODE:   .EQU    $02        ; LED code to indicate decimal mode
BINMODE:   .EQU    $04        ; LED code to indicate binary mode
BEEPMODE:  .EQU    $80        ; switch the beeper on / off

; UART
UART_RX:   .EQU    $F014      ; address of UART receive data
UART_TX:   .EQU    $F034      ; address of UART transmit data
UART_STA:  .EQU    $F015      ; address of UART status
UART_CTL:  .EQU    $F035      ; address of UART control
; bit masks for UART status
UART_TXE:  .EQU $01           ; UART transmitter is free to accept a new byte
UART_RXR:  .EQU $02           ; there is a byte ready in the UART receiver
UART_RTS:  .EQU    $10        ; RTS line (write / read)
UART_CTS:  .EQU    $20        ; CTS line (read only)

